=== mlspp/lib/CMakeLists.txt ===
add_subdirectory(bytes)
add_subdirectory(hpke)
add_subdirectory(tls_syntax)
add_subdirectory(mls_vectors)
