=== debian/changelog ===
dpp (10.1.4+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Correct copyright inaccuracies.

 -- Ben Westover <bjw@debian.org>  Fri, 26 Dec 2025 18:02:12 -0500

dpp (10.1.3+dfsg-1) unstable; urgency=medium

  * Initial Package (Closes: #1108449)

 -- Ben Westover <me@benthetechguy.net>  Fri, 11 Jul 2025 14:26:46 -0400
