=== debian/control ===
Source: dpp
Section: libs
Maintainer: Ben Westover <bjw@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libopus-dev,
 libssl-dev,
 nlohmann-json3-dev,
 zlib1g-dev
Standards-Version: 4.7.3
Vcs-Git: https://salsa.debian.org/debian/dpp.git
Vcs-Browser: https://salsa.debian.org/debian/dpp
Homepage: https://dpp.dev
Rules-Requires-Root: no

Package: libdpp10.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Discord API Bot Library - Version 10.1
 D++ is a lightweight and simple library for Discord written in modern
 C++. It is designed to cover as much of the API specification as
 possible and to have a incredibly small memory footprint, even when
 caching large amounts of data.

Package: libdpp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libopus-dev,
 libssl-dev,
 nlohmann-json3-dev,
 zlib1g-dev,
 libdpp10.1 (= ${binary:Version})
Description: C++ Discord API Bot Library - development files
 D++ is a lightweight and simple library for Discord written in modern
 C++. It is designed to cover as much of the API specification as
 possible and to have a incredibly small memory footprint, even when
 caching large amounts of data.
 .
 This package contains development files for version 10.1 of the library.

Package: libdpp-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 libjs-highlight.js,
 fonts-jetbrains-mono-web,
 doxygen-awesome-css
Build-Profiles: <!nodoc>
Description: C++ Discord API Bot Library - documentation
 D++ is a lightweight and simple library for Discord written in modern
 C++. It is designed to cover as much of the API specification as
 possible and to have a incredibly small memory footprint, even when
 caching large amounts of data.
 .
 This package contains documentation for version 10.1 of the library.
