=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DDPP_USE_EXTERNAL_JSON=ON -DRUN_LDCONFIG=OFF -DDPP_BUILD_TEST=OFF

# Don't build docs if nodoc build is run
execute_after_dh_auto_build:
ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	doxygen
endif

execute_after_dh_auto_clean:
	rm -rf docs
	rm -f mlspp/include/namespace.h

override_dh_auto_test:
# Skip tests; almost all require network, and many require a Discord bot token.
