=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=auto \
https://github.com/brainboxdotcc/DPP/tags .*/v?(\d.*)@ARCHIVE_EXT@
